package cn.ibizlab.assetmanagement.core.workorder.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.assetmanagement.core.workorder.domain.WOOrigin;
import cn.ibizlab.assetmanagement.core.workorder.filter.WOOriginSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[WOOrigin] 服务对象接口
 */
public interface IWOOriginService extends IService<WOOrigin>{

    boolean create(WOOrigin et) ;
    void createBatch(List<WOOrigin> list) ;
    boolean update(WOOrigin et) ;
    void updateBatch(List<WOOrigin> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    WOOrigin get(String key) ;
    WOOrigin getDraft(WOOrigin et) ;
    boolean checkKey(WOOrigin et) ;
    boolean save(WOOrigin et) ;
    void saveBatch(List<WOOrigin> list) ;
    Page<WOOrigin> searchDefault(WOOriginSearchContext context) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<WOOrigin> getWooriginByIds(List<String> ids) ;
    List<WOOrigin> getWooriginByEntities(List<WOOrigin> entities) ;
}


